<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?PHP
   include_once("security_check.php") ; 
	 
 // First set up the GLOBAL space
 
 // the xml file we want to parse
 $xmlSource = $epg_xmlSource ;

 //First we define a number of variables to store the data from each element

 $element_map["title"] = "epgTitle" ;
 $element_map["sub-title"] = "epgSubTitle" ;
 $element_map["desc"] = "epgDescription" ;
 $element_map["length"] = "epgDuration" ;
 $element_map["display-name"] = "xmlChannelName" ;
 $element_map["quality"] = "epgQuality" ;

 $epgTitle="";
 $epgSubTitle="";
 $epgDuration="";
 $epgChannel="";
 $epgDescription="";
 $epgStart="";
 $epgStop="";
 $epgRepeat=false;
 $epgQuality="";
 $epgPID = 0 ;

 $currentElement="";	//holds the name of the current element


/*	The start Element Handler	
*	This is where we store the element name, currently being parsed, in $currentElement.
*	This is also where we get the attribute, if any.
*/
function startElement($parser,$name,$attr){
		
	$GLOBALS['currentElement']=$name;	
	
	if(strcmp($name,"programme")==0){
		$GLOBALS['epgStart']    = to_local_time($attr["start"]);
		$GLOBALS['epgStop']     = to_local_time($attr["stop"]);
		//$GLOBALS['epgChannel']  = $attr["channel"];
		$GLOBALS['epgChannel']  = $GLOBALS['chn_name'][$attr["channel"]];
		add_diag("[XMLREAD] prog channel ".$attr["channel"]." = ".$GLOBALS['chn_name'][$attr["channel"]]) ;
		$GLOBALS['epgPID']      = $GLOBALS['epgPID']+1;  // store the next PID
		$GLOBALS['epgRepeat']   = false;  // initially assume not a repeat
		//echo "start PID=".$GLOBALS['epgPID']."<br>\n";
	}
	if(strcmp($name,"previously-shown")==0){
		$GLOBALS['epgRepeat'] = true;
	}
	if(strcmp($name,"channel")==0){
		$GLOBALS['xml_chnid'] = $attr["id"];
	}
	
}//end startElement()


/*	
*	The end Element Handler
*/

function endElement($parser,$name){
	$elements=array('epgPID','epgTitle','epgSubTitle','epgDuration','epgChannel','epgDescription','epgStart','epgStop','epgRepeat','epgQuality');     

      //if(strcmp($name,"quality")==0){ echo "<!-- EPG quality ".$GLOBALS["epgQuality"]." -->\n" ;
      if(strcmp($name,"programme")==0){
			 $GLOBALS["epgDuration"] = calc_duration($GLOBALS["epgDuration"],$GLOBALS["epgStart"],$GLOBALS["epgStop"]) ;
			 foreach($elements as $element){
				$temp[$element]=$GLOBALS[$element];							
			 }
			 
			 // Then store the programme
			 $s1 = $GLOBALS["start_time"] ;
			 $s2 = substr($GLOBALS["epgStart"],0,12) ;
			 $e1 = $GLOBALS["end_time"] ;
			 $e2 = substr($GLOBALS["epgStop"],0,12) ;
			 
			 $ss = (strcmp($s1,$s2)<0) && (strcmp($s2,$e1)<0) ;
			 $ee = (strcmp($s1,$e2)<0) && (strcmp($e2,$e1)<0) ;
			 
			 //echo "s=$s2=$ss e=$e2=$ee or=".($ss or $ee)."<br>\n" ;
			 
			 if( ($ss or $ee) and !$GLOBALS["chn_hide"][$GLOBALS["epgChannel"]] and ($GLOBALS["epgDuration"]>=$GLOBALS["minimum_duration"]) and in_array($GLOBALS["epgChannel"],$GLOBALS['Channels']) )
			 {		
			  //echo "ok s=$s2=$ss e=$e2=$ee or=".($ss or $ee)." $s2 $e2<br>\n" ;
			  $GLOBALS['programmes'][$GLOBALS["epgPID"]]=$temp;
		    $GLOBALS['channels'][$GLOBALS['epgChannel']] = true ;
			 }
 
       /*After storing the data we reset our global show-variables to
         hold a new show*/
       $GLOBALS['epgTitle']="";
       $GLOBALS['epgSubTitle']="";
       $GLOBALS['epgChannel']="";
       $GLOBALS['epgDuration']="";
       $GLOBALS['epgDescription']="";
       $GLOBALS['epgStart']="";
       $GLOBALS['epgStop']="";
       $GLOBALS['epgRepeat']="";
       $GLOBALS['epgQuality']="";
      }
			
	  if(strcmp($name,"channel")==0){
		 $x = trim($GLOBALS['xmlChannelName']) ;
		 if( array_key_exists($x,$GLOBALS['xml_chn_trans']) ) { $x = $GLOBALS['xml_chn_trans'][$x] ; }
		 $GLOBALS['chn_name'][$GLOBALS['xml_chnid']] = $x ;
		 add_diag("[XMLREAD] channel map ".$GLOBALS["xml_chnid"]." = ".$x." = ".$GLOBALS['xmlChannelName']) ;
		 $GLOBALS['xmlChannelName'] = "" ;
	  }

}//end endElement()


/*	The character data Handler
*	Depending on what the currentElement is, 
*	the handler assigns the value to the appropriate variable
*/

function characterData($parser, $data) {
global $element_map ;
        $elements = array (
             'title', 'sub-title', 'desc', 'length', 'display-name', 'quality'
        );

        foreach ($elements as $element) {
            if ($GLOBALS["currentElement"] == $element) {
                $GLOBALS[$element_map[$element]] .= $data;
            }
        }
    }

/*	This is where the actual parsing is going on.
*	parseFile() parses the xml document and return an array
*	with the data we asked for.
*/

function parseFile(){
	global $xmlSource,$programmes;
	
	/*Creating the xml parser*/
	$xml_parser=xml_parser_create();
	
	/*Register the handlers*/
	xml_set_element_handler($xml_parser,"startElement","endElement");
	xml_set_character_data_handler($xml_parser,"characterData");
	
	/*Disables case-folding. Needed for this example*/
	xml_parser_set_option($xml_parser,XML_OPTION_CASE_FOLDING,false);
	
	/*Open the xml file and feed it to the parser in 4k blocks*/
   //if(!($fp=fopen($xmlSource,"r"))) { die("Cannot open  $xmlSource  "); }
   if(!($fp=fopen($xmlSource,"r"))) { return false ; }
   //while(($data=fread($fp,4096))){
   while(($data=fread($fp,131072))){

 add_diag("processing XML") ;
 
      if(!xml_parse($xml_parser,$data,feof($fp))){
	     die(sprintf("XML error at line %d column %d ", 
                      xml_get_current_line_number($xml_parser), 
                      xml_get_current_column_number($xml_parser)));
	  }
 add_diag("reading XML") ;
   }
     
	 /*Finish ! we free the parser and returns the array*/
	 xml_parser_free($xml_parser);
	 
	 return $programmes;
	
}//end parseFile()

function calc_duration($duration,$start,$stop) {
 if ($duration<>"") { return $duration ; }
 return ((to_timestamp($stop)-to_timestamp($start))/60) ;
}

function to_timestamp($timestring) {
 $x = strtotime(substr($timestring,0,4)."/".substr($timestring,4,2)."/".substr($timestring,6,2)." ".substr($timestring,8,2).":".substr($timestring,10,2)) ;
 //add_diag("[XMLREAD] time $timestring = $x") ;
 return $x ;
}

function to_local_time($timestring) {
 $x = strtotime(substr($timestring,0,4)."/".substr($timestring,4,2)."/".substr($timestring,6,2)." ".substr($timestring,8,2).":".substr($timestring,10,2)) ;
 $xoff = ( (substr($timestring,15,1)."1")*( (substr($timestring,16,2)*60)+substr($timestring,18,2) ) ) ;
 $y = $x-($xoff*60) ;
 $zoff = local_offset($y) ;
 $z = $y+($zoff*60) ;
 $zt = date(YmdHis,$z)." ".zone_string($zoff) ;
 //add_diag("[XMLREAD] offset $timestring $x $xoff $y $z $zt") ;
 return $zt ;
}

?>

